package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.feign.WmshboundFeign;
import com.steerinfo.dil.mapper.DilBatchMapper;
import com.steerinfo.dil.model.AmsshipCargoTransferResult;
import com.steerinfo.dil.mapper.AmsshipCargoTransferResultMapper;
import com.steerinfo.dil.model.DilBatch;
import com.steerinfo.dil.service.IAmsshipCargoTransferResultService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * AmsshipCargoTransferResult服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-18 03:36
 * 类描述
 * 修订历史：
 * 日期：2021-08-18
 * 作者：generator
 * 参考：
 * 描述：AmsshipCargoTransferResult服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "amsshipCargoTransferResultService")
public class AmsshipCargoTransferResultServiceImpl implements IAmsshipCargoTransferResultService {

    @Autowired
    private AmsshipCargoTransferResultMapper amsshipCargoTransferResultMapper;
    @Autowired
    WmshboundFeign wmshboundFeign;
    @Autowired
    private DilBatchMapper dilBatchMapper;

    @Override
    public List<Map<String, Object>> seletCargoTransfer(Map<String, Object> mapVal) {
        return amsshipCargoTransferResultMapper.seletCargoTransfer(mapVal);
    }

    @Override
    @Transactional
    public int addCargoTransferResult(Map<String,Object> map) {
        AmsshipCargoTransferResult amsshipCargoTransferResult=new AmsshipCargoTransferResult();
        //货权转移编号
        BigDecimal cargoTransferResultId = amsshipCargoTransferResultMapper.selectCargoId();
        amsshipCargoTransferResult.setCargoTransferResultId(cargoTransferResultId);
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
        String  date=sdf.format(new Date());
        String resultNumber="ZY"+date+"00"+cargoTransferResultId;
        amsshipCargoTransferResult.setResultNumber(resultNumber);
        //同时新增批次
        //获取外轮船名
        String foreignShipName = (String)map.get("foreignShipName");
        Integer materialId=(Integer)map.get("materialId");
        //调用新增批次方法
        DilBatch dilBatch=new DilBatch();
        BigDecimal batchId1=dilBatchMapper.selectBatchId();
        dilBatch.setBatchId(batchId1);
        dilBatch.setInsertTime(new Date());
        dilBatch.setResultForeignShipName(foreignShipName);
        dilBatch.setMaterialId(new BigDecimal(materialId));
        dilBatch.setInsertUsername("admin");
        dilBatchMapper.insertSelective(dilBatch);
        // 修改港存库实时库存
        //获取收货人id
        Integer groupId =(Integer)map.get("groupId");
        amsshipCargoTransferResult.setGroupId(new BigDecimal(groupId));
        BigDecimal portId = amsshipCargoTransferResultMapper.selectPortId(new BigDecimal(groupId));
        //获取放货数量
        String resultNumberOfLoans1 =(String) map.get("resultNumberOfLoans");
        amsshipCargoTransferResult.setResultNumberOfLoans(new BigDecimal(resultNumberOfLoans1));
        BigDecimal batchId = dilBatch.getBatchId();
        Map<String,Object> map1 = new HashMap<>();
        map1.put("portId",portId);
        map1.put("batchId",batchId);
        map1.put("resultMaterialNumber",new BigDecimal(resultNumberOfLoans1));
        wmshboundFeign.addWarehousingResult(map1);
        //获取批次id进行新增
        amsshipCargoTransferResult.setBatchId(dilBatch.getBatchId());
        //获取货权转移送达单位
        Integer carrierId =(Integer)map.get("carrierId");
        amsshipCargoTransferResult.setCarrierId(new BigDecimal(carrierId));
        //获取联系人
        String resultContactPerson =(String)map.get("resultContactPerson");
        amsshipCargoTransferResult.setResultContactPerson(resultContactPerson);
        //获取联系方式
        String resultTelephoneFax =(String)map.get("resultTelephoneFax");
        amsshipCargoTransferResult.setResultTelephoneFax(resultTelephoneFax);

        //获取货代信息
        String resultFreightForwardingInfo = (String)map.get("resultFreightForwardingInfo");
        amsshipCargoTransferResult.setResultFreightForwardingInfo(resultFreightForwardingInfo);
        //获取备注
        String resultMemo =(String) map.get("resultMemo");
        amsshipCargoTransferResult.setResultMemo(resultMemo);
        amsshipCargoTransferResult.setResultDateOfLoans(new Date());
        //  设置常规字段
        amsshipCargoTransferResult.setInsertTime(new Date());
        amsshipCargoTransferResult.setDeleteName(null);
        amsshipCargoTransferResult.setDeleteTime(null);
        amsshipCargoTransferResult.setInsertUsername("admin");
        amsshipCargoTransferResult.setUpdateTime(new Date());
        amsshipCargoTransferResult.setInsertUpdateRemark("无");
        amsshipCargoTransferResult.setUpdateUsername("admin");
        amsshipCargoTransferResult.setDeleted(new BigDecimal(0));
        return amsshipCargoTransferResultMapper.insertSelective(amsshipCargoTransferResult);
    }

    @Override
    public int deleteByPrimaryKey(BigDecimal cargoTransferResultId) {
        return amsshipCargoTransferResultMapper.deleteByPrimaryKey(cargoTransferResultId);
    }

    @Override
    public int updateByPrimaryKey(BigDecimal cargoTransferResultId) {
        return amsshipCargoTransferResultMapper.updateByPrimaryKey(cargoTransferResultId);
    }

    @Override
    public BigDecimal selectMaxId() {
        return amsshipCargoTransferResultMapper.selectMaxId();
    }

    @Override
    public AmsshipCargoTransferResult selectByPrimaryKey(BigDecimal cargoTransferResultId) {
        return amsshipCargoTransferResultMapper.selectByPrimaryKey(cargoTransferResultId);
    }

    @Override
    public List<Map<String, Object>> getGroup(Map<String,Object> map) {
        return amsshipCargoTransferResultMapper.getGroup(map);
    }

    @Override
    public List<Map<String, Object>> getCargoId() {
        return amsshipCargoTransferResultMapper.getCargoId();
    }
    //删除
    @Override
    public int updateByPrimaryKeySelective(AmsshipCargoTransferResult amsshipCargoTransferResult) {
        return amsshipCargoTransferResultMapper.updateByPrimaryKeySelective(amsshipCargoTransferResult);
    }

    @Override
    public List<Map<String,Object>> selectByOrder(Integer cargoTransferResultId) {
        return amsshipCargoTransferResultMapper.selectByOrder(cargoTransferResultId);
    }

    @Override
    public List<Map<String, Object>> insertBetchId() {
        return amsshipCargoTransferResultMapper.insertBetchId();
    }

    @Override
    public List<Map<String, Object>> selectMaterialId(Map<String,Object> map) {
        return amsshipCargoTransferResultMapper.selectMaterialId(map);
    }

    @Override
    public List<Map<String, Object>> selectShipperName(Map<String,Object> map) {
        return amsshipCargoTransferResultMapper.selectShipperName(map);
    }


}
